//	Copyright (C) 2011 Michael McMaster <michael@codesrc.com>
//
//	This file is part of glBoy.
//
//	glBoy is free software: you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation, either version 3 of the License, or
//	(at your option) any later version.
//
//	glBoy is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with glBoy.  If not, see <http://www.gnu.org/licenses/>.

#ifndef GLBOY_GAMEBOYCART_HH
#define GLBOY_GAMEBOYCART_HH

#include "glBoy.hh"
#include "Core.hh"

namespace glBoy
{

class GameboyCart
{
public:
	GameboyCart(Core& core, uint8_t* rom, size_t size);

	void setRamBank(size_t bank);
private:
	Core& m_core;

	std::vector<std::shared_ptr<MemoryMap::Memory> > m_romBanks;
	std::vector<std::shared_ptr<MemoryMap::Memory> > m_ramBanks;
};

} // namespace glBoy

#endif
