static size_t regMask_r[8] =
{
	offsetof(glBoy::Registers, B) / 1,
	offsetof(glBoy::Registers, C) / 1,
	offsetof(glBoy::Registers, D) / 1,
	offsetof(glBoy::Registers, E) / 1,
	offsetof(glBoy::Registers, H) / 1,
	offsetof(glBoy::Registers, L) / 1,
	size_t(-1),
	offsetof(glBoy::Registers, A) / 1
};

static size_t regMask_d[4] =
{
	offsetof(glBoy::Registers, BC) / 2,
	offsetof(glBoy::Registers, DE) / 2,
	offsetof(glBoy::Registers, HL) / 2,
	offsetof(glBoy::Registers, SP) / 2
};

static size_t regMask_s[4] =
{
	offsetof(glBoy::Registers, BC) / 2,
	offsetof(glBoy::Registers, DE) / 2,
	offsetof(glBoy::Registers, HL) / 2,
	offsetof(glBoy::Registers, SP) / 2
};

static size_t regMask_q[4] =
{
	offsetof(glBoy::Registers, BC) / 2,
	offsetof(glBoy::Registers, DE) / 2,
	offsetof(glBoy::Registers, HL) / 2,
	offsetof(glBoy::Registers, AF) / 2
};

static void* OpcodeTable[256] =
{
&&NOP,	&&LD_dd_nn,	&&LD__BC__A,	&&INC_ss,	
&&INC_r,	&&DEC_r,	&&LD_r_n,	&&RLCA,	
&&LD__nn__SP,	&&ADD_HL__ss,	&&LD_A__BC_,	&&DEC_ss,	
&&INC_r,	&&DEC_r,	&&LD_r_n,	&&RRCA,	
&&STOP,	&&LD_dd_nn,	&&LD__DE__A,	&&INC_ss,	
&&INC_r,	&&DEC_r,	&&LD_r_n,	&&RLA,	
&&JR_e,	&&ADD_HL__ss,	&&LD_A__DE_,	&&DEC_ss,	
&&INC_r,	&&DEC_r,	&&LD_r_n,	&&RRA,	
&&JR_NZ__e,	&&LD_dd_nn,	&&LD__HLI__A,	&&INC_ss,	
&&INC_r,	&&DEC_r,	&&LD_r_n,	&&DAA,	
&&JR_Z__e,	&&ADD_HL__ss,	&&LD_A___HLI_,	&&DEC_ss,	
&&INC_r,	&&DEC_r,	&&LD_r_n,	&&CPL,	
&&JR_NC__e,	&&LD_dd_nn,	&&LD__HLD__A,	&&INC_ss,	
&&INC__HL_,	&&DEC__HL_,	&&LD__HL__n,	&&SCF,	
&&JR_C__e,	&&ADD_HL__ss,	&&LD_A__HLD_,	&&DEC_ss,	
&&INC_r,	&&DEC_r,	&&LD_r_n,	&&CCF,	
&&LD_r_r_,	&&LD_r_r_,	&&LD_r_r_,	&&LD_r_r_,	
&&LD_r_r_,	&&LD_r_r_,	&&LD_r__HL_,	&&LD_r_r_,	
&&LD_r_r_,	&&LD_r_r_,	&&LD_r_r_,	&&LD_r_r_,	
&&LD_r_r_,	&&LD_r_r_,	&&LD_r__HL_,	&&LD_r_r_,	
&&LD_r_r_,	&&LD_r_r_,	&&LD_r_r_,	&&LD_r_r_,	
&&LD_r_r_,	&&LD_r_r_,	&&LD_r__HL_,	&&LD_r_r_,	
&&LD_r_r_,	&&LD_r_r_,	&&LD_r_r_,	&&LD_r_r_,	
&&LD_r_r_,	&&LD_r_r_,	&&LD_r__HL_,	&&LD_r_r_,	
&&LD_r_r_,	&&LD_r_r_,	&&LD_r_r_,	&&LD_r_r_,	
&&LD_r_r_,	&&LD_r_r_,	&&LD_r__HL_,	&&LD_r_r_,	
&&LD_r_r_,	&&LD_r_r_,	&&LD_r_r_,	&&LD_r_r_,	
&&LD_r_r_,	&&LD_r_r_,	&&LD_r__HL_,	&&LD_r_r_,	
&&LD__HL__r,	&&LD__HL__r,	&&LD__HL__r,	&&LD__HL__r,	
&&LD__HL__r,	&&LD__HL__r,	&&HALT,	&&LD__HL__r,	
&&LD_r_r_,	&&LD_r_r_,	&&LD_r_r_,	&&LD_r_r_,	
&&LD_r_r_,	&&LD_r_r_,	&&LD_r__HL_,	&&LD_r_r_,	
&&ADD_A_r,	&&ADD_A_r,	&&ADD_A_r,	&&ADD_A_r,	
&&ADD_A_r,	&&ADD_A_r,	&&ADD_A__HL_,	&&ADD_A_r,	
&&ADC_A_r,	&&ADC_A_r,	&&ADC_A_r,	&&ADC_A_r,	
&&ADC_A_r,	&&ADC_A_r,	&&ADC_A__HL_,	&&ADC_A_r,	
&&SUB_A_r,	&&SUB_A_r,	&&SUB_A_r,	&&SUB_A_r,	
&&SUB_A_r,	&&SUB_A_r,	&&SUB_A__HL_,	&&SUB_A_r,	
&&SBC_A_r,	&&SBC_A_r,	&&SBC_A_r,	&&SBC_A_r,	
&&SBC_A_r,	&&SBC_A_r,	&&SBC_A__HL_,	&&SBC_A_r,	
&&AND_A_r,	&&AND_A_r,	&&AND_A_r,	&&AND_A_r,	
&&AND_A_r,	&&AND_A_r,	&&AND_A__HL_,	&&AND_A_r,	
&&XOR_A_r,	&&XOR_A_r,	&&XOR_A_r,	&&XOR_A_r,	
&&XOR_A_r,	&&XOR_A_r,	&&XOR_A__HL_,	&&XOR_A_r,	
&&OR_A_r,	&&OR_A_r,	&&OR_A_r,	&&OR_A_r,	
&&OR_A_r,	&&OR_A_r,	&&OR_A__HL_,	&&OR_A_r,	
&&CP_r,	&&CP_r,	&&CP_r,	&&CP_r,	
&&CP_r,	&&CP_r,	&&CP__HL_,	&&CP_r,	
&&RET_NZ,	&&pop_qq,	&&JP_NZ,	&&JP_nn,	
&&CALL_NZ,	&&push_qq,	&&ADD_A_n,	&&RST_p,	
&&RET_Z,	&&RET,	&&JP_Z,	&&CB,	
&&CALL_Z,	&&CALL_nn,	&&ADC_A_n,	&&RST_p,	
&&RET_NC,	&&pop_qq,	&&JP_NC,	&&NOP_D3,	
&&CALL_NC,	&&push_qq,	&&SUB_A_n,	&&RST_p,	
&&RET_C,	&&RETI,	&&JP_C,	&&NOP_DB,	
&&CALL_C,	&&NOP_DD,	&&SBC_A_n,	&&RST_p,	
&&LD__FF00_n__A,	&&pop_qq,	&&LD__FF00_C__A,	&&NOP_E3,	
&&NOP_E4,	&&push_qq,	&&AND_A_n,	&&RST_p,	
&&ADD_SP_d,	&&JP__HL_,	&&LD__N__A,	&&NOP_EB,	
&&NOP_EC,	&&BAD_OPCODE,	&&XOR_A_n,	&&RST_p,	
&&LD_A__FF00_d_,	&&pop_qq,	&&NOP_F2,	&&DI,	
&&NOP_F4,	&&push_qq,	&&OR_A_n,	&&RST_p,	
&&LDHL_SP_d,	&&LD_SP_HL,	&&LD_A__N_,	&&EI,	
&&NOP_FC,	&&NOP_FD,	&&CP_n,	&&RST_p
};

static void* OpcodeTableCB[256] =
{
&&RLC_r,	&&RLC_r,	&&RLC_r,	&&RLC_r,	
&&RLC_r,	&&RLC_r,	&&RLC__HL_,	&&RLC_r,	
&&RRC_r,	&&RRC_r,	&&RRC_r,	&&RRC_r,	
&&RRC_r,	&&RRC_r,	&&RRC__HL_,	&&RRC_r,	
&&RL_r,	&&RL_r,	&&RL_r,	&&RL_r,	
&&RL_r,	&&RL_r,	&&RL__HL_,	&&RL_r,	
&&RR_r,	&&RR_r,	&&RR_r,	&&RR_r,	
&&RR_r,	&&RR_r,	&&RR__HL_,	&&RR_r,	
&&SLA_r,	&&SLA_r,	&&SLA_r,	&&SLA_r,	
&&SLA_r,	&&SLA_r,	&&SLA__HL_,	&&SLA_r,	
&&SRA_r,	&&SRA_r,	&&SRA_r,	&&SRA_r,	
&&SRA_r,	&&SRA_r,	&&SRA__HL_,	&&SRA_r,	
&&SWAP_r,	&&SWAP_r,	&&SWAP_r,	&&SWAP_r,	
&&SWAP_r,	&&SWAP_r,	&&BAD_OPCODE,	&&SWAP_r,	
&&SRL_r,	&&SRL_r,	&&SRL_r,	&&SRL_r,	
&&SRL_r,	&&SRL_r,	&&SRL__HL_,	&&SRL_r,	
&&BIT_b_r,	&&BIT_b_r,	&&BIT_b_r,	&&BIT_b_r,	
&&BIT_b_r,	&&BIT_b_r,	&&BIT_b__HL_,	&&BIT_b_r,	
&&BIT_b_r,	&&BIT_b_r,	&&BIT_b_r,	&&BIT_b_r,	
&&BIT_b_r,	&&BIT_b_r,	&&BIT_b__HL_,	&&BIT_b_r,	
&&BIT_b_r,	&&BIT_b_r,	&&BIT_b_r,	&&BIT_b_r,	
&&BIT_b_r,	&&BIT_b_r,	&&BIT_b__HL_,	&&BIT_b_r,	
&&BIT_b_r,	&&BIT_b_r,	&&BIT_b_r,	&&BIT_b_r,	
&&BIT_b_r,	&&BIT_b_r,	&&BIT_b__HL_,	&&BIT_b_r,	
&&BIT_b_r,	&&BIT_b_r,	&&BIT_b_r,	&&BIT_b_r,	
&&BIT_b_r,	&&BIT_b_r,	&&BIT_b__HL_,	&&BIT_b_r,	
&&BIT_b_r,	&&BIT_b_r,	&&BIT_b_r,	&&BIT_b_r,	
&&BIT_b_r,	&&BIT_b_r,	&&BIT_b__HL_,	&&BIT_b_r,	
&&BIT_b_r,	&&BIT_b_r,	&&BIT_b_r,	&&BIT_b_r,	
&&BIT_b_r,	&&BIT_b_r,	&&BIT_b__HL_,	&&BIT_b_r,	
&&BIT_b_r,	&&BIT_b_r,	&&BIT_b_r,	&&BIT_b_r,	
&&BIT_b_r,	&&BIT_b_r,	&&BIT_b__HL_,	&&BIT_b_r,	
&&RES_b_r,	&&RES_b_r,	&&RES_b_r,	&&RES_b_r,	
&&RES_b_r,	&&RES_b_r,	&&RES_b__HL_,	&&RES_b_r,	
&&RES_b_r,	&&RES_b_r,	&&RES_b_r,	&&RES_b_r,	
&&RES_b_r,	&&RES_b_r,	&&RES_b__HL_,	&&RES_b_r,	
&&RES_b_r,	&&RES_b_r,	&&RES_b_r,	&&RES_b_r,	
&&RES_b_r,	&&RES_b_r,	&&RES_b__HL_,	&&RES_b_r,	
&&RES_b_r,	&&RES_b_r,	&&RES_b_r,	&&RES_b_r,	
&&RES_b_r,	&&RES_b_r,	&&RES_b__HL_,	&&RES_b_r,	
&&RES_b_r,	&&RES_b_r,	&&RES_b_r,	&&RES_b_r,	
&&RES_b_r,	&&RES_b_r,	&&RES_b__HL_,	&&RES_b_r,	
&&RES_b_r,	&&RES_b_r,	&&RES_b_r,	&&RES_b_r,	
&&RES_b_r,	&&RES_b_r,	&&RES_b__HL_,	&&RES_b_r,	
&&RES_b_r,	&&RES_b_r,	&&RES_b_r,	&&RES_b_r,	
&&RES_b_r,	&&RES_b_r,	&&RES_b__HL_,	&&RES_b_r,	
&&RES_b_r,	&&RES_b_r,	&&RES_b_r,	&&RES_b_r,	
&&RES_b_r,	&&RES_b_r,	&&RES_b__HL_,	&&RES_b_r,	
&&SET_b_r,	&&SET_b_r,	&&SET_b_r,	&&SET_b_r,	
&&SET_b_r,	&&SET_b_r,	&&SET_b__HL_,	&&SET_b_r,	
&&SET_b_r,	&&SET_b_r,	&&SET_b_r,	&&SET_b_r,	
&&SET_b_r,	&&SET_b_r,	&&SET_b__HL_,	&&SET_b_r,	
&&SET_b_r,	&&SET_b_r,	&&SET_b_r,	&&SET_b_r,	
&&SET_b_r,	&&SET_b_r,	&&SET_b__HL_,	&&SET_b_r,	
&&SET_b_r,	&&SET_b_r,	&&SET_b_r,	&&SET_b_r,	
&&SET_b_r,	&&SET_b_r,	&&SET_b__HL_,	&&SET_b_r,	
&&SET_b_r,	&&SET_b_r,	&&SET_b_r,	&&SET_b_r,	
&&SET_b_r,	&&SET_b_r,	&&SET_b__HL_,	&&SET_b_r,	
&&SET_b_r,	&&SET_b_r,	&&SET_b_r,	&&SET_b_r,	
&&SET_b_r,	&&SET_b_r,	&&SET_b__HL_,	&&SET_b_r,	
&&SET_b_r,	&&SET_b_r,	&&SET_b_r,	&&SET_b_r,	
&&SET_b_r,	&&SET_b_r,	&&SET_b__HL_,	&&SET_b_r,	
&&SET_b_r,	&&SET_b_r,	&&SET_b_r,	&&SET_b_r,	
&&SET_b_r,	&&SET_b_r,	&&SET_b__HL_,	&&SET_b_r
};

