//	Copyright (C) 2011 Michael McMaster <michael@codesrc.com>
//
//	This file is part of glBoy.
//
//	glBoy is free software: you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation, either version 3 of the License, or
//	(at your option) any later version.
//
//	glBoy is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with glBoy.  If not, see <http://www.gnu.org/licenses/>.

#ifndef GLBOY_UTIL_HH
#define GLBOY_UTIL_HH

#include <string>
namespace glBoy
{
	static char hexChars[] =
		{'0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'};

	inline std::string hex(uint8_t val)
	{
		std::string result("0xFF");
		result[2] = hexChars[val >> 4];
		result[3] = hexChars[val & 0xf];
		return result;
	}

	inline std::string hex(int8_t val)
	{
		std::string result;

		if (val >= 0)
		{
			result = "0x";
		}
		else
		{
			result = "-0x";
		}
		result += hexChars[val >> 4];
		result += hexChars[val & 0xf];
		return result;
	}

	inline std::string hex(uint16_t val)
	{
		std::string result("0xFFFF");
		result[2] = hexChars[val >> 12];
		result[3] = hexChars[(val >> 8) & 0xf];
		result[4] = hexChars[(val >> 4) & 0xf];
		result[5] = hexChars[val & 0xf];
		return result;
	}
}
#endif

